#ifndef HAVE_PTRIE
#define HAVE_PTRIE

#ifdef __cplusplus
extern "C" {
#endif

#include "ptrie_exports.h"

enum ptrie_result
{
    PR_OK,
    PR_ERROR
};

struct ptrie;
struct ptrie_iterator;

typedef enum ptrie_result ptrie_result;
typedef struct ptrie ptrie;
typedef struct ptrie_iterator ptrie_iterator;
typedef void (*ptrie_value_free)(void *);

PTRIE_EXPORT ptrie_result ptrie_new(ptrie_value_free free, ptrie **);
PTRIE_EXPORT ptrie_result ptrie_free(ptrie **);
PTRIE_EXPORT ptrie_result ptrie_set(ptrie *, unsigned int, char *, void *);
PTRIE_EXPORT ptrie_result ptrie_get(ptrie *, unsigned int, char *, void **);
PTRIE_EXPORT ptrie_result ptrie_delete(ptrie *, unsigned int,char *);

PTRIE_EXPORT ptrie_result ptrie_get_length(ptrie *,unsigned int *);
PTRIE_EXPORT ptrie_result ptrie_iterate(ptrie *,ptrie_iterator **);
PTRIE_EXPORT ptrie_result ptrie_iterator_next(ptrie_iterator *);
PTRIE_EXPORT ptrie_result ptrie_iterator_get_key_length(ptrie_iterator *,unsigned int *);
PTRIE_EXPORT ptrie_result ptrie_iterator_copy_key(ptrie_iterator *,char *);
PTRIE_EXPORT ptrie_result ptrie_iterator_get_value(ptrie_iterator *,void  **);
PTRIE_EXPORT ptrie_result ptrie_iterator_free(ptrie_iterator **);

#ifdef __cplusplus
}
#endif

#endif
